<?php

declare(strict_types=1);

// 140 - HOOK_SMARTY_OUTPUTFILTER

use Cin\Quickcategory5\CategoryService;
use JTL\Helpers\Category;
use JTL\Helpers\Text;
use JTL\Shop;

require \dirname(__DIR__, 2).'/src/warmup.php';

if ( ! $L->canRun()) {
  return;
}

$getText = Shop::Container()->getGetText();
$oldLang = $getText->getLanguage();
$getText->setLanguage(Text::convertISO2ISO639(Shop::getLanguageCode()));

$_plugin            = $P->getJTlPlugin();
$container          = null;
$position           = 'append';
$classList          = '';
$startingCategoryID = (int) $cfg['rootCategory'];
$rootHeader         = '';

// extend global cin config data
pq('head')->append(sprintf(include $_plugin->getPaths()->getBasePath().'src/jsconfig.php', $_plugin->getPluginID()));

switch (Shop::getPageType()) {
  case PAGE_STARTSEITE:
    if ( ! empty($cfg['html_selector_start'])) {
      $container = pq($cfg['html_selector_start']);
      $position  = $cfg['html_position_start'];
      $classList = $cfg['html_class_start'];
    }

    break;
  case PAGE_ARTIKELLISTE:
    if ( ! empty($cfg['html_selector_list'])) {
      $container          = pq($cfg['html_selector_list']);
      $position           = $cfg['html_position_list'];
      $classList          = $cfg['html_class_list'];
      $startingCategoryID = 'on' === $cfg['dynamicRoot'] && 'off' === $cfg['legacyMode'] ? $smarty->getTemplateVars()['AktuelleKategorie']->getID() ?? 0 : $startingCategoryID;
    }

    break;
  case PAGE_ARTIKEL:
    if ( ! empty($cfg['html_selector_article'])) {
      $container = pq($cfg['html_selector_article']);
      $position  = $cfg['html_position_article'];
      $classList = $cfg['html_class_article'];
    }

    break;
  default:
    if (\in_array((string) Shop::getPageType(), explode(',', $cfg['id_list']), true) && ! empty($cfg['html_selector_further'])) {
      $container = pq($cfg['html_selector_further']);
      $position  = $cfg['html_position_further'];
      $classList = $cfg['html_class_further'];
    }

    break;
}

if (null !== $container && pq($container)->count()) {
  pq('head')->append('<script src="'.$_plugin->getPaths()->getFrontendURL().'js/'.('on' === $cfg['legacyMode'] ? 'legacy' : 'quickcategory').'.js"></script>');
  pq('head')->append('<link rel="stylesheet" href="'.$_plugin->getPaths()->getFrontendURL().'css/quickcategory.css"></link>');
  pq('head')->append('<link rel="stylesheet" href="'.$_plugin->getPaths()->getFrontendURL().'css/progress-loader.css"></link>');

  $optText     = '';
  $defaultText = '';

  if ('on' === $cfg['legacyMode']) {
    $startingCategoryID = PAGE_STARTSEITE === Shop::getPageType() ? $startingCategoryID : $smarty->getTemplateVars()['AktuelleKategorie']->getID();
    $sl                 = CategoryService::legacyLevel((int) $cfg['rootCategory'], $smarty->getTemplateVars()['AktuelleKategorie'], $levelnames);
    if (1 === $sl) {
      $startingCategoryID = (int) $cfg['rootCategory'];
    }
    $smarty
      ->assign('startlevel', $sl)
      ->assign('levelnames', $levelnames);
  }

  switch ($cfg['namingMode']) {
    case 'auto':
      $category = Category::getInstance()->getCategoryById($startingCategoryID);

      $optText     = __('choose category from');
      $defaultText = $category ? __('choose category from').' '.$category->getName() : __('choose category');

      break;
    case 'defaultHead':
    case 'custom':
      $optText = $defaultText = $_plugin->getLocalization()->getTranslation('user_hint') ?: __('choose category');

      if ($startingCategoryID) {
        $category   = Category::getInstance()->getCategoryById($startingCategoryID);
        $rootHeader = $category->getName();
      }

      break;

    default:
      $optText = $defaultText = __('choose category');

      break;
  }

  $smarty
    ->assign('arrowDirection', 'on' === $cfg['arrowLeft'] ? 'left' : 'up')
    ->assign('namingMode', $cfg['namingMode'])
    ->assign('defaultText', $defaultText)
    ->assign('resetChoise', 'on' === $cfg['resetChoise'])
    ->assign('showBreadcrumbs', 'on' === $cfg['showBreadcrumbs'])
    ->assign('optText', $optText)
    ->assign('maxDeep', $cfg['deepCategory'])
    ->assign('rootHeader', $rootHeader)
    ->assign('classList', $classList)
    ->assign('categoryList', CategoryService::getCategories($startingCategoryID, $cfg['sortCategory']))
    ->assign('frontend', $_plugin->getPaths()->getFrontendURL())
    ->assign('aliaslist', $_plugin->getLocalization()->getTranslation('user_headlines'))
    ->assign('aliaslistArray', explode(',', $_plugin->getLocalization()->getTranslation('user_headlines')));

  pq($container)->{$position}($smarty->fetch($_plugin->getPaths()->getFrontendPath().'template/'.('on' === $cfg['legacyMode'] ? 'legacy' : 'quickcategory').'.tpl'));
}
// 140 - HOOK_SMARTY_OUTPUTFILTER
